// HandlersAndList.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>


#include "ListOfHandlers.h"

using namespace std;





// ======================================================================================================

// An exemplary hanlder

class TPrintableHandler : public THandler
{
	private:

		string fString;

	public:

		TPrintableHandler( void ) : fString( "" ) {}
		TPrintableHandler( string & str ) : fString( str ) {}

		virtual void operator() ( void )
		{
			cout << fString.c_str() << endl;
		}

};


// ======================================================================================================


int main(int argc, char* argv[])
{
	cout << "Tera lista" << endl << endl;

	TListOfHandlers theList;

	theList.Add2Head( new TPrintableHandler( string( "Ala" ) ) );
	theList.Add2Head( new TPrintableHandler( string( "ma" ) ) );
	theList.Add2Head( new TPrintableHandler( string( "kota" ) ) );
	

	// Now traverse the list and exectue handlers
	for( THandler * ptr = theList.GetFirst(); ptr != 0; ptr = theList.GetNext() )
		( * ptr )();

	int dummy;
	cin >> dummy;
	
	
	return 0;
}

// ======================================================================================================




